diff --git a/drupal7/sites/all/modules/file_entity/file_entity.test b/drupal7/sites/all/modules/file_entity/file_entity.test
index 4cc4b9a7..2c72cbd8 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.test
+++ b/drupal7/sites/all/modules/file_entity/file_entity.test
@@ -683,7 +1000,7 @@ class FileEntityReplaceTestCase extends FileEntityTestHelper {
    */
   function testReplaceFile() {
     // Select the first text test file to use.
-    $file = reset($this->files['text']);
+    $file = $this->createFileEntity(array('type' => 'document'));
 
     // Create a user with file edit permissions.
     $user = $this->drupalCreateUser(array('edit any document files'));
@@ -697,9 +1014,9 @@ class FileEntityReplaceTestCase extends FileEntityTestHelper {
     $this->drupalPost(NULL, array(), t('Save'));
     $this->assertText(t('Document @file has been updated.', array('@file' => $file->filename)), 'File was updated without file upload.');
 
-    // Get the next text file to use as a replacement.
+    // Get a text file to use as a replacement.
     $original = clone $file;
-    $replacement = next($this->files['text']);
+    $replacement = $this->getTestFile('text');
 
     // Test that the file saves when uploading a replacement file.
     $edit = array();
@@ -718,7 +1035,7 @@ class FileEntityReplaceTestCase extends FileEntityTestHelper {
     $this->assertFalse(entity_load('file', FALSE, array('status' => 0)), 'Temporary file used for replacement was deleted.');
 
     // Get an image file.
-    $image = reset($this->files['image']);
+    $image = $this->getTestFile('image');
     $edit['files[replace_upload]'] = drupal_realpath($image->uri);
 
     // Test that validation works by uploading a non-text file as a replacement.
@@ -745,6 +1062,9 @@ class FileEntityReplaceTestCase extends FileEntityTestHelper {
   }
 }
 
+/**
+ * Tests file entity tokens.
+ */
 class FileEntityTokenTestCase extends FileEntityTestHelper {
   public static function getInfo() {
     return array(
@@ -756,25 +1076,26 @@ class FileEntityTokenTestCase extends FileEntityTestHelper {
 
   function setUp() {
     parent::setUp();
-    $this->setUpFiles();
   }
 
   function testFileEntityTokens() {
+    $file = $this->createFileEntity(array('type' => 'document'));
     $tokens = array(
       'type' => 'Document',
       'type:name' => 'Document',
       'type:machine-name' => 'document',
-      'type:count' => count($this->files['text']),
+      'type:count' => 1,
     );
-    $this->assertTokens('file', array('file' => $this->files['text'][0]), $tokens);
+    $this->assertTokens('file', array('file' => $file), $tokens);
 
+    $file = $this->createFileEntity(array('type' => 'image'));
     $tokens = array(
       'type' => 'Image',
       'type:name' => 'Image',
       'type:machine-name' => 'image',
-      'type:count' => count($this->files['image']),
+      'type:count' => 1,
     );
-    $this->assertTokens('file', array('file' => $this->files['image'][0]), $tokens);
+    $this->assertTokens('file', array('file' => $file), $tokens);
   }
 
   function assertTokens($type, array $data, array $tokens, array $options = array()) {
@@ -799,6 +1120,9 @@ class FileEntityTokenTestCase extends FileEntityTestHelper {
   }
 }
 
+/**
+ * Tests adding support for bundles to the core 'file' entity.
+ */
 class FileEntityTypeTestCase extends FileEntityTestHelper {
   public static function getInfo() {
     return array(
@@ -810,7 +1134,6 @@ class FileEntityTypeTestCase extends FileEntityTestHelper {
 
   function setUp() {
     parent::setUp();
-    $this->setUpFiles();
   }
 
   /**
@@ -836,148 +1159,6 @@ class FileEntityTypeTestCase extends FileEntityTestHelper {
     $this->assertEqual($loaded_type->label, $type_machine_label, "Was able to create a type and retreive it.");
   }
 
-
-  /**
-   * Ensures that the weight is respected when types are created.
-   * @return unknown_type
-   */
-  function testOrder() {
-//    $type = $this->createFileType(array('name' => 'last', 'label' => 'Last', 'weight' => 100));
-//    $type = $this->createFileType(array('name' => 'first', 'label' => 'First'));
-//    $types = media_type_get_types();
-//    $keys = array_keys($types);
-//    $this->assertTrue(isset($types['last']) && isset($types['first']), "Both types saved");
-//    $this->assertTrue(array_search('last', $keys) > array_search('first', $keys), 'Type which was supposed to be first came first');
-  }
-
-  /**
-   * Test view mode assignment.  Currently fails, don't know why.
-   * @return unknown_type
-   */
-  function testViewModesAssigned() {
-  }
-
-  /**
-   * Make sure candidates are presented in the case of multiple
-   * file types.
-   */
-  function testTypeWithCandidates() {
-    // Create multiple file types with the same mime types.
-    $types = array(
-      'image1' => $this->createFileType(array('type' => 'image1', 'label' => 'Image 1')),
-      'image2' => $this->createFileType(array('type' => 'image2', 'label' => 'Image 2'))
-    );
-
-    // Attach a text field to one of the file types.
-    $field = array(
-      'field_name' => drupal_strtolower($this->randomName()),
-      'type' => 'text',
-      'settings' => array(
-        'max_length' => 255,
-      )
-    );
-    field_create_field($field);
-    $instance = array(
-      'field_name' => $field['field_name'],
-      'entity_type' => 'file',
-      'bundle' => 'image2',
-      'widget' => array(
-        'type' => 'text_textfield',
-      ),
-      'display' => array(
-        'default' => array(
-          'type' => 'text_default',
-        ),
-      ),
-    );
-    field_create_instance($instance);
-
-    // Create a user with file creation access.
-    $user = $this->drupalCreateUser(array('create files'));
-    $this->drupalLogin($user);
-
-    // Step 1: Upload file
-    $file = reset($this->files['image']);
-    $edit = array();
-    $edit['files[upload]'] = drupal_realpath($file->uri);
-    $this->drupalPost('file/add', $edit, t('Next'));
-
-    // Step 2: Select file type candidate
-    $this->assertText('Image 1', 'File type candidate list item found.');
-    $this->assertText('Image 2', 'File type candidate list item found.');
-    $edit = array();
-    $edit['type'] = 'image2';
-    $this->drupalPost(NULL, $edit, t('Next'));
-
-    // Step 3: Select file scheme candidate
-    $this->assertText('Public local files served by the webserver.', 'File scheme candidate list item found.');
-    $this->assertText('Private local files served by Drupal.', 'File scheme candidate list item found.');
-    $edit = array();
-    $edit['scheme'] = 'public';
-    $this->drupalPost(NULL, $edit, t('Next'));
-
-    // Step 4: Complete field widgets
-    $langcode = LANGUAGE_NONE;
-    $edit = array();
-    $edit["{$field['field_name']}[$langcode][0][value]"] = $this->randomName();
-    $this->drupalPost(NULL, $edit, t('Save'));
-    $this->assertRaw(t('!type %name was uploaded.', array('!type' => 'Image 2', '%name' => $file->filename)), t('Image 2 file updated.'));
-    $this->assertText($field['field_name'], 'File text field was found.');
-  }
-
-  /**
-   * Make sure no candidates appear when only one mime type is available.
-   * NOTE: Depends on file_entity.module default 'image' type.
-   */
-  function testTypeWithoutCandidates() {
-    // Attach a text field to the default image file type.
-    $field = array(
-      'field_name' => drupal_strtolower($this->randomName()),
-      'type' => 'text',
-      'settings' => array(
-        'max_length' => 255,
-      )
-    );
-    field_create_field($field);
-    $instance = array(
-      'field_name' => $field['field_name'],
-      'entity_type' => 'file',
-      'bundle' => 'image',
-      'widget' => array(
-        'type' => 'text_textfield',
-      ),
-      'display' => array(
-        'default' => array(
-          'type' => 'text_default',
-        ),
-      ),
-    );
-    field_create_instance($instance);
-
-    // Create a user with file creation access.
-    $user = $this->drupalCreateUser(array('create files'));
-    $this->drupalLogin($user);
-
-    // Step 1: Upload file
-    $file = reset($this->files['image']);
-    $edit = array();
-    $edit['files[upload]'] = drupal_realpath($file->uri);
-    $this->drupalPost('file/add', $edit, t('Next'));
-
-    // Step 2: Scheme selection
-    if ($this->xpath('//input[@name="scheme"]')) {
-      $this->drupalPost(NULL, array(), t('Next'));
-    }
-
-    // Step 3: Complete field widgets
-    $langcode = LANGUAGE_NONE;
-    $edit = array();
-    $edit["{$field['field_name']}[$langcode][0][value]"] = $this->randomName();
-    $this->drupalPost(NULL, $edit, t('Save'));
-    $this->assertRaw(t('!type %name was uploaded.', array('!type' => 'Image', '%name' => $file->filename)), t('Image file uploaded.'));
-    $this->assertText($field['field_name'], 'File text field was found.');
-  }
-
   /**
    * Test file types CRUD UI.
    */
@@ -1067,6 +1248,9 @@ class FileEntityTypeTestCase extends FileEntityTestHelper {
   }
 }
 
+/**
+ * Tests the file entity access API.
+ */
 class FileEntityAccessTestCase extends FileEntityTestHelper {
 
   public static function getInfo() {
@@ -1079,33 +1263,20 @@ class FileEntityAccessTestCase extends FileEntityTestHelper {
 
   function setUp() {
     parent::setUp();
-    $this->setUpFiles(array('uid' => 0));
 
-    // Unset the fact that file_entity_install() adds the 'view files'
-    // permission to all user roles. This messes with being able to fully unit
-    // test the file_entity_access() function.
+    // Remove the "view files" permission which is set by default for all users
+    // so we can test this permission correctly.
     $roles = user_roles();
     foreach ($roles as $rid => $role) {
       user_role_revoke_permissions($rid, array('view files'));
     }
   }
 
-  /**
-   * Asserts file_entity_access correctly grants or denies access.
-   */
-  function assertFileEntityAccess($ops, $file, $account) {
-    drupal_static_reset('file_entity_access');
-    foreach ($ops as $op => $result) {
-      $msg = t("file_entity_access returns @result with operation '@op'.", array('@result' => $result ? 'true' : 'false', '@op' => $op));
-      $this->assertEqual($result, file_entity_access($op, $file, $account), $msg);
-    }
-  }
-
   /**
    * Runs basic tests for file_entity_access function.
    */
   function testFileEntityAccess() {
-    $file = reset($this->files['image']);
+    $file = $this->createFileEntity(array('type' => 'image'));
 
     // Ensures user with 'bypass file access' permission can do everything.
     $web_user = $this->drupalCreateUser(array('bypass file access'));
@@ -1164,70 +1335,165 @@ class FileEntityAccessTestCase extends FileEntityTestHelper {
   }
 
   /**
-   * Test to see if we have access to view files when granted the permissions.
-   * In this test we aim to prove the permissions work in the following pages:
+   * Tests page access.
+   *
+   * Verifies the privileges required to access the following pages:
    *  file/add
    *  file/%/view
    *  file/%/download
    *  file/%/edit
+   *  file/%/usage
    *  file/%/delete
    */
   function testFileEntityPageAccess() {
-    $web_user = $this->drupalCreateUser(array());
+    // Test creating files without permission.
+    $web_user = $this->drupalCreateUser();
     $this->drupalLogin($web_user);
     $this->drupalGet('file/add');
     $this->assertResponse(403, 'Users without access can not access the file add page');
-    $web_user = $this->drupalCreateUser(array('create files'));
-    $this->drupalLogin($web_user);
+
+    // Test creating files with permission.
+    user_role_change_permissions(DRUPAL_AUTHENTICATED_RID, array(
+      'create files' => TRUE,
+    ));
     $this->drupalGet('file/add');
     $this->assertResponse(200, 'Users with access can access the file add page');
 
-    $file = reset($this->files['text']);
+    $file = $this->createFileEntity(array('type' => 'document','uid' => $web_user->uid));
 
-    // This fails.. No clue why but, tested manually and works as should.
-    //$web_user = $this->drupalCreateUser(array('view own files'));
-    //$this->drupalLogin($web_user);
-    //$this->drupalGet("file/{$file->fid}/view");
-    //$this->assertResponse(403, 'Users without access can not access the file view page');
-    $web_user = $this->drupalCreateUser(array('view files'));
-    $this->drupalLogin($web_user);
+    // Test viewing own files without permission.
+    $this->drupalGet("file/{$file->fid}/view");
+    $this->assertResponse(403, 'Users without access can not view their own files');
+
+    // Test viewing own files with permission.
+    user_role_change_permissions(DRUPAL_AUTHENTICATED_RID, array(
+      'view own files' => TRUE,
+    ));
+    $this->drupalGet("file/{$file->fid}/view");
+    $this->assertResponse(200, 'Users with access can view their own files');
+
+    // Test viewing any files without permission.
+    $file->uid = 1;
+    file_save($file);
+    $this->drupalGet("file/{$file->fid}/view");
+    $this->assertResponse(403, 'Users with access can not view any file');
+
+    // Test viewing any files with permission.
+    user_role_change_permissions(DRUPAL_AUTHENTICATED_RID, array(
+      'view files' => TRUE,
+    ));
     $this->drupalGet("file/{$file->fid}/view");
-    $this->assertResponse(200, 'Users with access can access the file view page');
+    $this->assertResponse(200, 'Users with access can view any file');
 
+    // Test downloading own files without permission.
+    $file->uid = $web_user->uid;
+    file_save($file);
     $url = "file/{$file->fid}/download";
-    $web_user = $this->drupalCreateUser(array());
-    $this->drupalLogin($web_user);
     $this->drupalGet($url, array('query' => array('token' => file_entity_get_download_token($file))));
-    $this->assertResponse(403, 'Users without access can not download the file');
-    $web_user = $this->drupalCreateUser(array('download any document files'));
-    $this->drupalLogin($web_user);
+    $this->assertResponse(403, 'Users without access can not download their own files');
+
+    // Test downloading own files with permission.
+    user_role_change_permissions(DRUPAL_AUTHENTICATED_RID, array(
+      'download own document files' => TRUE,
+    ));
+    $this->drupalGet($url, array('query' => array('token' => file_entity_get_download_token($file))));
+    $this->assertResponse(200, 'Users with access can download their own files');
+
+    // Test downloading any files without permission.
+    $file->uid = 1;
+    file_save($file);
+    $url = "file/{$file->fid}/download";
     $this->drupalGet($url, array('query' => array('token' => file_entity_get_download_token($file))));
-    $this->assertResponse(200, 'Users with access can download the file');
+    $this->assertResponse(403, 'Users without access can not download any file');
+
+    // Test downloading any files with permission.
+    user_role_change_permissions(DRUPAL_AUTHENTICATED_RID, array(
+      'download any document files' => TRUE,
+    ));
+    $this->drupalGet($url, array('query' => array('token' => file_entity_get_download_token($file))));
+    $this->assertResponse(200, 'Users with access can download any file');
+
+    // Test downloading files with an invalid token.
     $this->drupalGet($url, array('query' => array('token' => 'invalid-token')));
-    $this->assertResponse(403, 'Cannot download file with in invalid token.');
+    $this->assertResponse(403, 'Cannot download file with an invalid token.');
+
+    // Test downloading files without a token.
     $this->drupalGet($url);
     $this->assertResponse(403, 'Cannot download file without a token.');
     variable_set('file_entity_allow_insecure_download', TRUE);
+
+    // Test downloading files with permission but without a token when insecure
+    // downloads are enabled.
     $this->drupalGet($url);
     $this->assertResponse(200, 'Users with access can download the file without a token when file_entity_allow_insecure_download is set.');
 
-    $web_user = $this->drupalCreateUser(array());
-    $this->drupalLogin($web_user);
+    // Tests editing own files without permission.
+    $file->uid = $web_user->uid;
+    file_save($file);
     $this->drupalGet("file/{$file->fid}/edit");
-    $this->assertResponse(403, 'Users without access can not access the file edit page');
-    $web_user = $this->drupalCreateUser(array('edit any document files'));
-    $this->drupalLogin($web_user);
+    $this->assertResponse(403, 'Users without access can not edit own files');
+
+    // Tests checking the usage of their own files without permission.
+    $this->drupalGet("file/{$file->fid}/usage");
+    $this->assertResponse(403, 'Users without access can not check the usage of their own files');
+
+    // Tests editing own files with permission.
+    user_role_change_permissions(DRUPAL_AUTHENTICATED_RID, array(
+      'edit own document files' => TRUE,
+    ));
     $this->drupalGet("file/{$file->fid}/edit");
-    $this->assertResponse(200, 'Users with access can access the file add page');
+    $this->assertResponse(200, 'Users with access can edit own files');
 
-    $web_user = $this->drupalCreateUser(array());
-    $this->drupalLogin($web_user);
+    // Tests checking the usage of their own files without permission.
+    $this->drupalGet("file/{$file->fid}/usage");
+    $this->assertResponse(200, 'Users with access can check the usage of their own files');
+
+    // Tests editing any files without permission.
+    $file->uid = 1;
+    file_save($file);
+    $this->drupalGet("file/{$file->fid}/edit");
+    $this->assertResponse(403, 'Users without access can not edit any file');
+
+    // Tests checking the usage of any files without permission.
+    $this->drupalGet("file/{$file->fid}/usage");
+    $this->assertResponse(403, 'Users without access can not check the usage of any file');
+
+    // Tests editing any files with permission.
+    user_role_change_permissions(DRUPAL_AUTHENTICATED_RID, array(
+      'edit any document files' => TRUE,
+    ));
+    $this->drupalGet("file/{$file->fid}/edit");
+    $this->assertResponse(200, 'Users with access can edit any file');
+
+    // Tests checking the usage of any files with permission.
+    $this->drupalGet("file/{$file->fid}/usage");
+    $this->assertResponse(200, 'Users with access can check the usage of any file');
+
+    // Tests deleting own files without permission.
+    $file->uid = $web_user->uid;
+    file_save($file);
     $this->drupalGet("file/{$file->fid}/delete");
-    $this->assertResponse(403, 'Users without access can not access the file view page');
-    $web_user = $this->drupalCreateUser(array('delete any document files'));
-    $this->drupalLogin($web_user);
+    $this->assertResponse(403, 'Users without access can not delete their own files');
+
+    // Tests deleting own files with permission.
+    user_role_change_permissions(DRUPAL_AUTHENTICATED_RID, array(
+      'delete own document files' => TRUE,
+    ));
     $this->drupalGet("file/{$file->fid}/delete");
-    $this->assertResponse(200, 'Users with access can access the file add page');
+    $this->assertResponse(200, 'Users with access can delete their own files');
+
+    // Tests deleting any files without permission.
+    $file->uid = 1;
+    file_save($file);
+    $this->drupalGet("file/{$file->fid}/delete");
+    $this->assertResponse(403, 'Users without access can not delete any file');
+
+    // Tests deleting any files with permission.
+    user_role_change_permissions(DRUPAL_AUTHENTICATED_RID, array(
+      'delete any document files' => TRUE,
+    ));
+    $this->drupalGet("file/{$file->fid}/delete");
+    $this->assertResponse(200, 'Users with access can delete any file');
   }
 
   /**
@@ -1244,10 +1510,7 @@ class FileEntityAccessTestCase extends FileEntityTestHelper {
 
       // Create private, permanent files owned by this user only he's an owner.
       if (!empty($case['owner'])) {
-        $file = next($this->files['text']);
-        $file->uid = $account->uid;
-        file_save($file);
-        $file = file_move($file, 'private://');
+        $file = $this->createFileEntity(array('type' => 'document', 'uid' => $account->uid, 'scheme' => 'private'));
 
         // Check if the physical file is there.
         $arguments = array('%name' => $file->filename, '%username' => $account->name, '%uri' => $file->uri);
@@ -1266,8 +1529,71 @@ class FileEntityAccessTestCase extends FileEntityTestHelper {
       }
     }
   }
+
+  /**
+   * Asserts file_entity_access correctly grants or denies access.
+   */
+  function assertFileEntityAccess($ops, $file, $account) {
+    drupal_static_reset('file_entity_access');
+    foreach ($ops as $op => $result) {
+      $msg = t("file_entity_access returns @result with operation '@op'.", array('@result' => $result ? 'true' : 'false', '@op' => $op));
+      $this->assertEqual($result, file_entity_access($op, $file, $account), $msg);
+    }
+  }
+
+  /**
+   * Helper for testFileEntityPrivateDownloadAccess() test.
+   *
+   * Defines several cases for accesing private files.
+   *
+   * @return array
+   *   Array of associative arrays, each one having the next keys:
+   *   - "message" string with the assertion message.
+   *   - "permissions" array of permissions or NULL for anonymous user.
+   *   - "expect" expected HTTP response code.
+   *   - "owner" Optional boolean indicating if the user is a file owner.
+   */
+  function getPrivateDownloadAccessCases() {
+    return array(
+      array(
+        'message' => "File owners cannot download their own files unless they are granted the 'view own private files' permission.",
+        'permissions' => array(),
+        'expect' => 403,
+        'owner' => TRUE,
+      ),
+      array(
+        'message' => "File owners can download their own files as they have been granted the 'view own private files' permission.",
+        'permissions' => array('view own private files'),
+        'expect' => 200,
+        'owner' => TRUE,
+      ),
+      array(
+        'message' => "Anonymous users cannot download private files.",
+        'permissions' => NULL,
+        'expect' => 403,
+      ),
+      array(
+        'message' => "Authenticated users cannot download each other's private files.",
+        'permissions' => array(),
+        'expect' => 403,
+      ),
+      array(
+        'message' => "Users who can view public files are not able to download private files.",
+        'permissions' => array('view files'),
+        'expect' => 403,
+      ),
+      array(
+        'message' => "Users who bypass file access can download any file.",
+        'permissions' => array('bypass file access'),
+        'expect' => 200,
+      ),
+    );
+  }
 }
 
+/**
+ * Tests overriding file attributes.
+ */
 class FileEntityAttributeOverrideTestCase extends FileEntityTestHelper {
 
   public static function getInfo() {
@@ -1278,11 +1604,6 @@ class FileEntityAttributeOverrideTestCase extends FileEntityTestHelper {
     );
   }
 
-  function setUp() {
-    parent::setUp();
-    $this->setUpFiles();
-  }
-
   /**
    * Test to see if file attributes can be overridden.
    */
@@ -1295,19 +1616,20 @@ class FileEntityAttributeOverrideTestCase extends FileEntityTestHelper {
 
     );
 
-    // Retrieve an image file entity for testing.
-    $file = reset($this->files['image']);
+    // Create an image file entity for testing.
+    $file = $this->createFileEntity(array('type' => 'image'));
 
     // Override a variety of attributes.
     foreach ($overrides as $override => $value) {
       $file->override['attributes'][$override] = $value;
     }
 
-    // Test that the attributes have been overridden.
+    // Build just the file portion of a file entity.
     $build = file_view_file($file, 'full');
 
+    // Verify that all of the overrides replaced the attributes.
     foreach ($overrides as $attribute => $expected_value) {
-      $this->assertEqual($build['#item'][$attribute], $expected_value, format_string('The %attribute was overridden correctly.', array('%attribute' => $attribute)));
+      $this->assertEqual($build['#file']->$attribute, $expected_value, format_string('The %attribute was overridden correctly.', array('%attribute' => $attribute)));
     }
   }
 }
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.theme.inc b/drupal7/sites/all/modules/file_entity/file_entity.theme.inc
index 1819d979..6801b2d8 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.theme.inc
+++ b/drupal7/sites/all/modules/file_entity/file_entity.theme.inc
@@ -96,6 +96,9 @@ function theme_file_entity_file_audio($variables) {
   if ($variables['loop']) {
     $audio_attributes['loop'] = 'loop';
   }
+  if (!empty($variables['preload'])) {
+    $audio_attributes['preload'] = $variables['preload'];
+  }
 
   $output .= '<audio' . drupal_attributes($audio_attributes) . '>';
   foreach ($files as $delta => $file) {
@@ -148,6 +151,9 @@ function theme_file_entity_file_video($variables) {
   if ($variables['height']) {
     $video_attributes['height'] = $variables['height'];
   }
+  if (!empty($variables['preload'])) {
+    $video_attributes['preload'] = $variables['preload'];
+  }
 
   $output .= '<video' . drupal_attributes($video_attributes) . '>';
   foreach ($files as $delta => $file) {
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.views.inc b/drupal7/sites/all/modules/file_entity/file_entity.views.inc
index 6a37901d..101123a0 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.views.inc
+++ b/drupal7/sites/all/modules/file_entity/file_entity.views.inc
@@ -162,3 +162,13 @@ function file_entity_views_plugins() {
     ),
   );
 }
+
+/**
+ * Implements hook_views_query_substitutions().
+ */
+function file_entity_views_query_substitutions() {
+  return array(
+    '***ADMINISTER_FILES***' => intval(user_access('administer files')),
+    '***BYPASS_FILE_ACCESS***' =>  intval(user_access('bypass file access')),
+  );
+}
diff --git a/drupal7/sites/all/modules/file_entity/plugins/entity/PanelizerEntityFile.class.php b/drupal7/sites/all/modules/file_entity/plugins/entity/PanelizerEntityFile.class.php
new file mode 100644
index 00000000..7f15dfbc
--- /dev/null
+++ b/drupal7/sites/all/modules/file_entity/plugins/entity/PanelizerEntityFile.class.php
@@ -0,0 +1,123 @@
+<?php
+/**
+ * @file
+ * Class for the Panelizer file entity plugin.
+ */
+
+/**
+ * Panelizer Entity file plugin class.
+ *
+ * Handles file specific functionality for Panelizer.
+ */
+class PanelizerEntityFile extends PanelizerEntityDefault {
+  public $entity_admin_root = 'admin/structure/file-types/%';
+  public $entity_admin_bundle = 3;
+  public $views_table = 'file_managed';
+
+  public function entity_access($op, $entity) {
+    return file_entity_access($op, $entity);
+  }
+
+  /**
+   * Implement the save function for the entity.
+   */
+  public function entity_save($entity) {
+    file_save($entity);
+  }
+
+  /**
+   * Implement the save function for the entity.
+   */
+  public function entity_allows_revisions($entity) {
+    return array(FALSE, FALSE);
+
+  }
+
+  public function settings_form(&$form, &$form_state) {
+    parent::settings_form($form, $form_state);
+
+    $warn = FALSE;
+    foreach ($this->plugin['bundles'] as $info) {
+      if (!empty($info['status'])) {
+        $warn = TRUE;
+        break;
+      }
+    }
+
+    if ($warn) {
+      $task = page_manager_get_task('file_view');
+      if (!empty($task['disabled'])) {
+        drupal_set_message('The file template page is currently not enabled in page manager. You must enable this for Panelizer to be able to panelize files.', 'warning');
+      }
+
+      $handler = page_manager_load_task_handler($task, '', 'file_view_panelizer');
+      if (!empty($handler->disabled)) {
+        drupal_set_message('The panelizer variant on the file template page is currently not enabled in page manager. You must enable this for Panelizer to be able to panelize files.', 'warning');
+      }
+    }
+  }
+
+  public function entity_identifier($entity) {
+    return t('This file');
+  }
+
+  public function entity_bundle_label() {
+    return t('File type');
+  }
+
+  function get_default_display($bundle, $view_mode) {
+    // For now we just go with the empty display.
+    // @todo come up with a better default display.
+    return parent::get_default_display($bundle, $view_mode);
+  }
+
+  /**
+   * Implements a delegated hook_page_manager_handlers().
+   *
+   * This makes sure that all panelized entities have the proper entry
+   * in page manager for rendering.
+   */
+  public function hook_default_page_manager_handlers(&$handlers) {
+    page_manager_get_task('file_view');
+
+    $handler = new stdClass;
+    $handler->disabled = FALSE; /* Edit this to true to make a default handler disabled initially */
+    $handler->api_version = 1;
+    $handler->name = 'file_view_panelizer';
+    $handler->task = 'file_view';
+    $handler->subtask = '';
+    $handler->handler = 'panelizer_node';
+    $handler->weight = -100;
+    $handler->conf = array(
+      'title' => t('File panelizer'),
+      'context' => 'argument_entity_id:file_1',
+      'access' => array(),
+    );
+    $handlers['file_view_panelizer'] = $handler;
+
+    return $handlers;
+  }
+
+  /**
+   * Implements a delegated hook_form_alter.
+   *
+   * We want to add Panelizer settings for the bundle to the file type form.
+   */
+  public function hook_form_alter(&$form, &$form_state, $form_id) {
+    if ($form_id == 'file_entity_file_type_form') {
+      if (isset($form['#file_type'])) {
+        $bundle = $form['#file_type']->type;
+        $this->add_bundle_setting_form($form, $form_state, $bundle, array('machine_name'));
+      }
+    }
+  }
+
+  public function hook_page_alter(&$page) {
+
+  }
+
+  public function hook_views_plugins_alter(&$plugins) {
+
+  }
+
+}
diff --git a/drupal7/sites/all/modules/file_entity/plugins/entity/file.inc b/drupal7/sites/all/modules/file_entity/plugins/entity/file.inc
new file mode 100644
index 00000000..fd582311
--- /dev/null
+++ b/drupal7/sites/all/modules/file_entity/plugins/entity/file.inc
@@ -0,0 +1,22 @@
+<?php
+/**
+ * @file
+ * Definition of the Panelizer file plugin.
+ */
+
+$plugin = array(
+  'handler' => 'PanelizerEntityFile',
+  'entity path' => 'file/%file',
+  'uses page manager' => TRUE,
+  'hooks' => array(
+    'menu' => TRUE,
+    'admin_paths' => TRUE,
+    'permission' => TRUE,
+    'panelizer_defaults' => TRUE,
+    'default_page_manager_handlers' => TRUE,
+    'form_alter' => TRUE,
+    'page_alter' => TRUE,
+    'views_data_alter' => TRUE,
+    'views_plugins_alter' => TRUE,
+  ),
+);
